/*******************************************************************
 *
 *    DESCRIPTION: rings generator
 *
 *    AUTHOR: NaiX (aka gpf)
 *
 *******************************************************************/

if (app.documents.length > 0)
{
	//============================================
	var tmpRulerUnits = app.preferences.rulerUnits;
	var tmpTypeUnits = app.preferences.typeUnits;
	app.preferences.rulerUnits = Units.PIXELS;
	app.preferences.typeUnits = TypeUnits.PIXELS;
	//============================================
	var iterations = 12;			// -   
	var defED = 1.5;				//        ()
	var defR = .5;				//    ()
	var defDist = 30;				//    ()
	var outlineWidth = 2;			//   ( )
	var dx = defDist;				
	var dy = defDist;				
	var outline = true;			
	var colorIn = new CMYKColor();
	colorIn.black = colorIn.cyan = colorIn.yellow = colorIn.magenta = 0;		// inner color
	var colorOut = new CMYKColor();
	colorOut.black = colorOut.cyan = colorOut.yellow = colorOut.magenta = 30;	// outline color

	var rx;
	var ry;
	var rt;
	var rc;
	var radius = defR;
	var ed = defED;
	var dW	= parseFloat(app.activeDocument.width);
	var dH	= parseFloat(app.activeDocument.height);
	var res = parseFloat(app.activeDocument.resolution);
	var mW = (dW / res * 2.54);
	var mH = (dH / res * 2.54);
	var dpcm = dW/mW;		
	var edP = ed * dpcm;	

	mW-=ed*2;
	mH-=ed*2;
	
	//functions
	function floor2(val)
	{
		var tmp = Math.floor(val);
		return ((val - tmp) > .5)?(tmp+1):tmp;
	}
	function correctDX()
	{
		if (rx < 2) rx = 2;
		dx = floor2(mW/(rx-1)*100)/100;
	}
	function correctDY()
	{
		if (ry < 2) ry = 2;
		dy = floor2(mH/(ry-1)*100)/100;
	}
	function showW(val)
	{
		dlg.panel0.stText2.text = floor2(val+ed*2 ) + " cm";
	}
	function showH(val)
	{
		dlg.panel0.stText3.text = floor2(val+ed*2) + " cm";
	}
	function showDX(val)
	{
		dlg.panel1.etEcDX.text = val;
	}
	function showDY(val)
	{
		dlg.panel1.etEcDY.text = val;
	}
	function showRX(val)
	{
		dlg.panel1.etEcRX.text = val;
	}
	function showRY(val)
	{
		dlg.panel1.etEcRY.text = val;
	}
	function showED(val)
	{
		dlg.panel2.etEcED.text = val;
	}
	function showR(val)
	{
		dlg.panel2.etEcLR.text = val;
	}
	function showRT()
	{
		rt = 2*rx+2*ry-4;
		dlg.panel1.etRT.text = rt;
	}
	function selL(x,y)
	{
		var selAr = new Array();
		var angle = 2*Math.PI/iterations;
		var dotR = dpcm * radius;
		var idx = 0;
		for (var i = 0; i< (2*Math.PI); i+=angle, idx++)
		{
			selAr[idx] = [Math.sin(i)*dotR+x, Math.cos(i)*dotR+y];
		}
		return selAr;
	}
	function genCol(y)
	{
		var step = (dW - (2 * edP))/(rx-1);
		var bx = edP;
		for (var i = 0; i < (rx); i++, bx+=step)
		{
			with (app.activeDocument.selection)
			{
				select(selL(bx, y));
				fill(colorIn);
				if (outline)
				{
					selectBorder(2);
					fill(colorOut);
				}
			}
			rc++;
			showPgs(rc, rt);
		}
	}
	function genRow(x)
	{
		var step = (dH - (2 * edP))/(ry-1);
		var by = edP;
		for (var i = 0; i < (ry); i++, by+=step)
		{
			with (app.activeDocument.selection)
			{
				select(selL(x, by));
				fill(colorIn);
				if (outline)
				{
					selectBorder(2);
					fill(colorOut);
				}
			}
			rc++;
			showPgs(rc, rt);
		}
	}
	function showPgs(val, total)
	{
		dlg.text = "Progress: " + floor2(val/(total + 4)*100) + " %";
	}
	function procDY()
	{
		if (isNaN(dy)) dy = defDist;
		ry = floor2(mH/dy)+1;
		correctDY();
		showDY(dy);
		showRY(ry);
		showRT();
		isValidParams();
	}
	function procRY()
	{
		if (isNaN(ry)) ry = 2;
		correctDY();
		showDY(dy);
		showRY(ry);
		showRT();
		isValidParams();
	}
	function isValidParams()
	{
		dlg.btnCreate.enabled = ((dx > 0)&&(dy > 0));
	}
	// dialog
	var dlg = new Window('dialog', 'Rings generator', [100, 100, 400, 420]);

	dlg.panel0 = dlg.add('panel', [5, 5, 290, 60], 'File info');
		dlg.panel0.stText0 = dlg.panel0.add('statictext', [50, 15, 150, 30], "width:");
		dlg.panel0.stText1 = dlg.panel0.add('statictext', [50, 32, 150, 47], "heigth:");
		dlg.panel0.stText2 = dlg.panel0.add('statictext', [150, 15, 270, 30]);
		dlg.panel0.stText3 = dlg.panel0.add('statictext', [150, 32, 270, 47]);

	dlg.panel1 = dlg.add('panel', [5, 65, 290, 198], 'Options');
		dlg.panel1.stText0 = dlg.panel1.add('statictext', [50, 15, 150, 35], "width distance:");
		dlg.panel1.stText1 = dlg.panel1.add('statictext', [50, 37, 150, 57], "height distance:");
		dlg.panel1.etEcDX = dlg.panel1.add('edittext', [150, 15, 200, 35]);
		dlg.panel1.etEcDY = dlg.panel1.add('edittext', [150, 37, 200, 57]);
		dlg.panel1.etEcDY.enabled = false
		dlg.panel1.cbLock = dlg.panel1.add('checkbox', [205, 37, 280, 57], "Unlock");

		dlg.panel1.stText2 = dlg.panel1.add('statictext', [50, 61, 150, 81], "rings in width:");
		dlg.panel1.stText3 = dlg.panel1.add('statictext', [50, 83, 150, 103], "rings in height:");
		dlg.panel1.etEcRX = dlg.panel1.add('edittext', [150, 61, 200, 81]);
		dlg.panel1.etEcRY = dlg.panel1.add('edittext', [150, 83, 200, 103]);
		dlg.panel1.etEcRY.enabled = false

		dlg.panel1.stText4 = dlg.panel1.add('statictext', [50, 105, 150, 125], "rings total:");
		dlg.panel1.etRT = dlg.panel1.add('edittext', [150, 105, 200, 125]);
		dlg.panel1.etRT.enabled = false;

	dlg.panel2 = dlg.add('panel', [5, 200, 290, 284], 'Label options');
		dlg.panel2.stText0 = dlg.panel2.add('statictext', [50, 15, 150, 35], "edge distance:");
		dlg.panel2.stText1 = dlg.panel2.add('statictext', [50, 37, 150, 57], "radius:");
		dlg.panel2.etEcED = dlg.panel2.add('edittext', [150, 15, 200, 35]);
		dlg.panel2.etEcLR = dlg.panel2.add('edittext', [150, 37, 200, 57]);
		dlg.panel2.cbOutline = dlg.panel2.add('checkbox', [100, 59, 200, 79], 'enable outline');
		dlg.panel2.cbOutline.value = outline;

	dlg.btnFinish = dlg.add('button', [155, 289, 265, 314], "Finish");
	dlg.btnCreate = dlg.add('button', [35, 289, 145, 314], "Create");

	// events
	dlg.panel1.cbLock.onClick = function()
	{
		with (dlg.panel1)
		{
			etEcDY.enabled = cbLock.value
			etEcRY.enabled = cbLock.value
		}
	}
	dlg.btnCreate.onClick = function()
	{
		outline = dlg.panel2.cbOutline.value;
		dlg.btnFinish.enabled = dlg.btnCreate.enabled = false;
		var dr = app.activeDocument;
		var rLayer = dr.artLayers.add();
		rLayer.name = 'rings ' + rt;
		rc = 0;
		genCol(edP);
		genRow(edP);
		genCol(dH - edP);
		genRow(dW - edP);
		dr.selection.deselect();
		dlg.btnFinish.enabled = dlg.btnCreate.enabled = true;
		dlg.text = "Rings generator";
	}
	dlg.btnFinish.onClick = function()																																									                                                                                                                                                                                                                                                                                                                                                                                                                    
	{
		dlg.close();
	}
	dlg.panel2.etEcED.onChange = function()
	{
		ed = this.text;
		if (isNaN(ed)||(ed<0)) ed = defED;
		edP = ed * dpcm;
		mW = floor2(dW / res * 2.54) - ed*2;
		mH = floor2(dH / res * 2.54) - ed*2;
		rx = floor2(mW/dx)+1;
		ry = floor2(mH/dy)+1;
		correctDX();
		correctDY();
		showED(ed);
		showDX(dx);
		showDY(dy);
		showRX(rx);
		showRY(ry);
		showRT();
		isValidParams();
	}
	dlg.panel2.etEcLR.onChange = function()
	{
		radius = this.text;
		if (isNaN(radius)||(radius<=0)) radius = defR;
		showR(radius);
	}
	dlg.panel1.etEcRX.onChange = function()
	{
		rx = this.text;
		if (!dlg.panel1.cbLock.value)
		{
			ry = this.text;
			procRY()
		}
		if (isNaN(rx)) rx = 2;
		correctDX();
		showDX(dx);
		showRX(rx);
		showRT();
		isValidParams();
	}
	dlg.panel1.etEcRY.onChange = function()
	{
		ry = this.text;
		procRY();
	}
	dlg.panel1.etEcDX.onChange = function()
	{
		dx = this.text;
		if (!dlg.panel1.cbLock.value)
		{
			dy = this.text;
			procDY();
		}
		if (isNaN(dx)) dx = defDist;
		rx = floor2(mW/dx)+1;
		correctDX();
		showDX(dx);
		showRX(rx);
		showRT();
		isValidParams();
	}
	dlg.panel1.etEcDY.onChange = function()
	{
		dy = this.text;
		procDY();
	}

	rx = floor2(mW/dx)+1;
	ry = floor2(mH/dy)+1;
	correctDX();
	correctDY();
	showRT();
	showW(mW);
	showH(mH);
	showDX(dx);
	showDY(dy);
	showRX(rx);
	showRY(ry);
	showED(ed);
	showR(radius);
	isValidParams();
	dlg.show();
	//============================================
	app.preferences.rulerUnits = tmpRulerUnits;
	app.preferences.typeUnits = tmpTypeUnits;
}
else alert ("Nothing to do...");